diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/LevelGenerator.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/LevelGenerator.java
index 4bc7eb155..04a27a2b2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/LevelGenerator.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/LevelGenerator.java
@@ -150,7 +150,7 @@ public final class LevelGenerator {
                     for (int y = 0; y < sizeY; y++) {
                         int id = 0;
                         if (y <= height) {
-                            id = Blocks.STONE.id;
+                            id = Blocks.STONE.id();
                         }
 
                         if (worldType == IndevWorldType.FLOATING && y < floatingLayerMinY) {
@@ -192,17 +192,17 @@ public final class LevelGenerator {
 
                     int height = heightMap[x + z * Chunk.CHUNK_SIZE_X];
                     int topBlock = result.getBlock(x, height + 1, z);
-                    if ((topBlock == Blocks.FLUID_WATER_FLOWING.id || topBlock == Blocks.FLUID_WATER_STILL.id || topBlock == 0)
+                    if ((topBlock == Blocks.FLUID_WATER_FLOWING.id() || topBlock == Blocks.FLUID_WATER_STILL.id() || topBlock == 0)
                         && height <= waterLevel - 1 && isGravel) {
-                        result.setBlock(x, height, z, Blocks.GRAVEL.id);
+                        result.setBlock(x, height, z, Blocks.GRAVEL.id());
                     }
 
                     if (topBlock == 0) {
                         int id = -1;
                         if (height <= beachHeight && isSand) {
-                            id = Blocks.SAND.id;
+                            id = Blocks.SAND.id();
                             if (worldTheme == IndevWorldTheme.HELL) {
-                                id = Blocks.GRASS.id;
+                                id = Blocks.GRASS.id();
                             }
                         }
 
@@ -222,7 +222,7 @@ public final class LevelGenerator {
                         int i = Chunk.makeBlockIndex(x, y, z);
                         int id = result.getBlock(x, y, z);
                         if (id == 0 && y < waterLevel) {
-                            result.setBlock(x, y, z, Blocks.FLUID_WATER_STILL.id);
+                            result.setBlock(x, y, z, Blocks.FLUID_WATER_STILL.id());
                         }
                     }
                 }
@@ -238,11 +238,11 @@ public final class LevelGenerator {
         for (int x = xSpawn - 3; x <= xSpawn + 3; x++) {
             for (int y = ySpawn - 2; y <= ySpawn + 2; y++) {
                 for (int z = zSpawn - 3; z <= zSpawn + 3; z++) {
-                    int id = y < ySpawn - 1 ? Blocks.OBSIDIAN.id : 0;
+                    int id = y < ySpawn - 1 ? Blocks.OBSIDIAN.id() : 0;
                     if (x == xSpawn - 3 || z == zSpawn - 3 || x == xSpawn + 3 || z == zSpawn + 3 || y == ySpawn - 2 || y == ySpawn + 2) {
-                        id = Blocks.STONE.id;
+                        id = Blocks.STONE.id();
                         if (y >= ySpawn - 1) {
-                            id = Blocks.PLANKS_OAK.id;
+                            id = Blocks.PLANKS_OAK.id();
                         }
                     }
 
@@ -255,7 +255,7 @@ public final class LevelGenerator {
             }
         }
 
-        world.setBlockWithNotify(xSpawn - 3 + 1, ySpawn + 2, zSpawn, Blocks.TORCH_COAL.id);
-        world.setBlockWithNotify(xSpawn + 3 - 1, ySpawn + 2, zSpawn, Blocks.TORCH_COAL.id);
+        world.setBlockWithNotify(xSpawn - 3 + 1, ySpawn + 2, zSpawn, Blocks.TORCH_COAL.id());
+        world.setBlockWithNotify(xSpawn + 3 - 1, ySpawn + 2, zSpawn, Blocks.TORCH_COAL.id());
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
index 6b7d61976..191b5727d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.world.generate.chunk.perlin.nether;
 
-import net.minecraft.core.block.BlockSand;
+import net.minecraft.core.block.BlockLogicSand;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
@@ -31,7 +31,7 @@ public class ChunkDecoratorNether
 
         Random rand = new Random((long) chunkX * 0x4f9939f508L + (long) chunkZ * 0x1ef1565bd5L);
 
-        BlockSand.fallInstantly = true;
+        BlockLogicSand.fallInstantly = true;
         int x = chunkX * 16;
         int z = chunkZ * 16;
         for(int i = 0; i < 8; i++)
@@ -39,7 +39,7 @@ public class ChunkDecoratorNether
             int xf = x + rand.nextInt(16) + 8;
             int yf = minY + rand.nextInt(rangeY - 8) + 4;
             int zf = z + rand.nextInt(16) + 8;
-            (new WorldFeatureNetherLava(Blocks.FLUID_LAVA_FLOWING.id)).place(world, rand, xf, yf, zf);
+            new WorldFeatureNetherLava(Blocks.FLUID_LAVA_FLOWING.id()).place(world, rand, xf, yf, zf);
         }
 
         for(int i = 0; i < 10; i++)
@@ -47,7 +47,7 @@ public class ChunkDecoratorNether
             int xf = x + rand.nextInt(16);
             int yf = minY + rand.nextInt(rangeY - 8) + 4;
             int zf = z + rand.nextInt(16);
-            (new WorldFeatureOre(Blocks.ORE_NETHERCOAL_NETHERRACK.id, 12)).place(world, rand, xf, yf, zf);
+            new WorldFeatureOre(Blocks.ORE_NETHERCOAL_NETHERRACK.id(), 12).place(world, rand, xf, yf, zf);
         }
 
         int max = rand.nextInt(rand.nextInt(10) + 1);
@@ -56,7 +56,7 @@ public class ChunkDecoratorNether
             int xf = x + rand.nextInt(16) + 8;
             int yf = minY + rand.nextInt(rangeY - 8) + 4;
             int zf = z + rand.nextInt(16) + 8;
-            (new WorldFeatureFire()).place(world, rand, xf, yf, zf);
+            new WorldFeatureFire().place(world, rand, xf, yf, zf);
         }
 
         max = rand.nextInt(rand.nextInt(10) + 1);
@@ -65,7 +65,7 @@ public class ChunkDecoratorNether
             int xf = x + rand.nextInt(16) + 8;
             int yf = minY + rand.nextInt(rangeY - 8) + 4;
             int zf = z + rand.nextInt(16) + 8;
-            (new WorldFeatureGlowstoneA()).place(world, rand, xf, yf, zf);
+            new WorldFeatureGlowstoneA().place(world, rand, xf, yf, zf);
         }
 
         for(int i = 0; i < 10; i++)
@@ -73,24 +73,24 @@ public class ChunkDecoratorNether
             int xf = x + rand.nextInt(16) + 8;
             int yf = minY + rand.nextInt(rangeY - 8) + 4;
             int zf = z + rand.nextInt(16) + 8;
-            (new WorldFeatureGlowstoneB()).place(world, rand, xf, yf, zf);
+            new WorldFeatureGlowstoneB().place(world, rand, xf, yf, zf);
         }
 
         if (rand.nextInt(8) == 0) {
             int xf = x + rand.nextInt(16) + 8;
             int yf = minY + rand.nextInt(rangeY - 16) + 8;
             int zf = z + rand.nextInt(16) + 8;
-            (new WorldFeatureLake(Blocks.FLUID_LAVA_STILL.id)).place(world, rand, xf, yf, zf);
+            new WorldFeatureLake(Blocks.FLUID_LAVA_STILL.id()).place(world, rand, xf, yf, zf);
         }
 
         for (int i = 0; i < /*20*/80; i++) {
             int xf = x + rand.nextInt(16);
             int yf = minY + rand.nextInt(rangeY);
             int zf = z + rand.nextInt(16);
-            (new WorldFeaturePumice(32)).place(world, rand, xf, yf, zf);
+            new WorldFeaturePumice(32).place(world, rand, xf, yf, zf);
         }
 
-        BlockSand.fallInstantly = false;
+        BlockLogicSand.fallInstantly = false;
 
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
index 30ab6ec5c..1243dfa7a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
@@ -88,19 +88,19 @@ public class SurfaceGeneratorNether
                             fillerBlock = (short) worldFillBlock;
                             if(generateGravelBeach)
                             {
-                                topBlock = (short) Blocks.GRAVEL.id;
+                                topBlock = (short) Blocks.GRAVEL.id();
                             }
                             if(generateGravelBeach)
                             {
-                                fillerBlock = (short) Blocks.COBBLE_NETHERRACK.id;
+                                fillerBlock = (short) Blocks.COBBLE_NETHERRACK.id();
                             }
                             if(generateSandBeach)
                             {
-                                topBlock = (short) Blocks.SOULSAND.id;
+                                topBlock = (short) Blocks.SOULSAND.id();
                             }
                             if(generateSandBeach)
                             {
-                                fillerBlock = (short) Blocks.SOULSAND.id;
+                                fillerBlock = (short) Blocks.SOULSAND.id();
                             }
                         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
index 67bd855e7..e61bd069e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
@@ -26,19 +26,19 @@ public class TerrainGeneratorNether
 
         if (y >= type.getMaxY() - rand.nextInt(5))
         {
-            return Blocks.BEDROCK.id;
+            return Blocks.BEDROCK.id();
         }
         else if (y >= halfHeight - rand.nextInt(5) && y <= halfHeight + 5 - rand.nextInt(5))
         {
-            return Blocks.BONESHALE.id;
+            return Blocks.BONESHALE.id();
         }
         else if (y <= type.getMinY() + rand.nextInt(5))
         {
-            return Blocks.BEDROCK.id;
+            return Blocks.BEDROCK.id();
         }
         else if (y <= halfHeight)
         {
-            return Blocks.SOULSCHIST.id;
+            return Blocks.SOULSCHIST.id();
         }
         else if (density > 0.0)
         {
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
index bb43679a1..b8e5eeb6d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
@@ -1,16 +1,15 @@
 package net.minecraft.core.world.generate.chunk.perlin.overworld;
 
-import net.minecraft.core.block.BlockLeavesBase;
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicLeavesBase;
+import net.minecraft.core.block.BlockLogicMoss;
+import net.minecraft.core.block.BlockLogicOreCoal;
+import net.minecraft.core.block.BlockLogicOreDiamond;
+import net.minecraft.core.block.BlockLogicOreGold;
+import net.minecraft.core.block.BlockLogicOreIron;
+import net.minecraft.core.block.BlockLogicOreLapis;
+import net.minecraft.core.block.BlockLogicOreRedstone;
+import net.minecraft.core.block.BlockLogicSand;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.BlockOreCoal;
-import net.minecraft.core.block.BlockOreDiamond;
-import net.minecraft.core.block.BlockOreGold;
-import net.minecraft.core.block.BlockOreIron;
-import net.minecraft.core.block.BlockOreLapis;
-import net.minecraft.core.block.BlockMoss;
-import net.minecraft.core.block.BlockOreRedstone;
-import net.minecraft.core.block.BlockSand;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biomes;
@@ -57,7 +56,7 @@ public class ChunkDecoratorOverworld
 
         float oreHeightModifier = rangeY / 128f;
 
-        BlockSand.fallInstantly = true;
+        BlockLogicSand.fallInstantly = true;
         int x = chunkX * 16;
         int z = chunkZ * 16;
         int y = world.getHeightValue(x + 16, z + 16);
@@ -77,7 +76,7 @@ public class ChunkDecoratorOverworld
                 {
                     int topBlock = world.getHeightValue(x + dx, z + dz);
                     int id = world.getBlockId(x + dx, topBlock - 1, z + dz);
-                    if (id == Blocks.GRASS.id)
+                    if (id == Blocks.GRASS.id())
                     {
                         boolean shouldPlaceWater = swampRand.nextFloat() < 0.5f;
                         if (shouldPlaceWater)
@@ -88,14 +87,14 @@ public class ChunkDecoratorOverworld
                             int negZId = world.getBlockId(x + dx, topBlock - 1, z + dz - 1);
                             int negYId = world.getBlockId(x + dx, topBlock - 2, z + dz);
                             if (
-                                    posXId != 0 && (Blocks.blocksList[posXId].blockMaterial.isSolid() || Blocks.blocksList[posXId].blockMaterial == Material.water) &&
-                                            negXId != 0 && (Blocks.blocksList[negXId].blockMaterial.isSolid() || Blocks.blocksList[negXId].blockMaterial == Material.water) &&
-                                            posZId != 0 && (Blocks.blocksList[posZId].blockMaterial.isSolid() || Blocks.blocksList[posZId].blockMaterial == Material.water) &&
-                                            negZId != 0 && (Blocks.blocksList[negZId].blockMaterial.isSolid() || Blocks.blocksList[negZId].blockMaterial == Material.water) &&
-                                            negYId != 0 && Blocks.blocksList[negYId].blockMaterial.isSolid()
+                                    posXId != 0 && (Blocks.blocksList[posXId].getMaterial().isSolid() || Blocks.blocksList[posXId].getMaterial() == Material.water) &&
+                                            negXId != 0 && (Blocks.blocksList[negXId].getMaterial().isSolid() || Blocks.blocksList[negXId].getMaterial() == Material.water) &&
+                                            posZId != 0 && (Blocks.blocksList[posZId].getMaterial().isSolid() || Blocks.blocksList[posZId].getMaterial() == Material.water) &&
+                                            negZId != 0 && (Blocks.blocksList[negZId].getMaterial().isSolid() || Blocks.blocksList[negZId].getMaterial() == Material.water) &&
+                                            negYId != 0 && Blocks.blocksList[negYId].getMaterial().isSolid()
                             )
                             {
-                                world.setBlock(x + dx, topBlock - 1, z + dz, Blocks.FLUID_WATER_STILL.id);
+                                world.setBlock(x + dx, topBlock - 1, z + dz, Blocks.FLUID_WATER_STILL.id());
                                 world.setBlock(x + dx, topBlock, z + dz, 0);
                             }
                         }
@@ -110,22 +109,22 @@ public class ChunkDecoratorOverworld
         if (biome == Biomes.OVERWORLD_DESERT)
             lakeChance = 0;
         if (lakeChance != 0 && rand.nextInt(lakeChance) == 0) {
-            int fluid = Blocks.FLUID_WATER_STILL.id;
+            int fluid = Blocks.FLUID_WATER_STILL.id();
             if (biome.hasSurfaceSnow())
             {
-                fluid = Blocks.ICE.id;
+                fluid = Blocks.ICE.id();
             }
             int i1 = x + rand.nextInt(16) + 8;
             int l4 = minY + rand.nextInt(rangeY);
             int i8 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureLake(fluid)).place(world, rand, i1, l4, i8);
+            new WorldFeatureLake(fluid).place(world, rand, i1, l4, i8);
         }
         if (rand.nextInt(8) == 0) {
             int xf = x + rand.nextInt(16) + 8;
             int yf = minY + rand.nextInt(rand.nextInt(rangeY - (rangeY / 16)) + (rangeY / 16));
             int zf = z + rand.nextInt(16) + 8;
             if (yf < minY + rangeY / 2 || rand.nextInt(10) == 0) {
-                (new WorldFeatureLake(Blocks.FLUID_LAVA_STILL.id)).place(world, rand, xf, yf, zf);
+                new WorldFeatureLake(Blocks.FLUID_LAVA_STILL.id()).place(world, rand, xf, yf, zf);
             }
         }
         for (int k1 = 0; k1 < (8 * oreHeightModifier); k1++) {
@@ -133,9 +132,9 @@ public class ChunkDecoratorOverworld
             int k8 = minY + rand.nextInt(rangeY);
             int j11 = z + rand.nextInt(16) + 8;
             if (rand.nextInt(2) == 0) {
-                (new WorldFeatureDungeon(Blocks.BRICK_CLAY.id, Blocks.BRICK_CLAY.id, null)).place(world, rand, j5, k8, j11);
+                new WorldFeatureDungeon(Blocks.BRICK_CLAY.id(), Blocks.BRICK_CLAY.id(), null).place(world, rand, j5, k8, j11);
             } else {
-                (new WorldFeatureDungeon(Blocks.COBBLE_STONE.id, Blocks.COBBLE_STONE_MOSSY.id, null)).place(world, rand, j5, k8, j11);
+                new WorldFeatureDungeon(Blocks.COBBLE_STONE.id(), Blocks.COBBLE_STONE_MOSSY.id(), null).place(world, rand, j5, k8, j11);
             }
         }
 
@@ -181,63 +180,63 @@ public class ChunkDecoratorOverworld
             int l5 = x + rand.nextInt(16);
             int i9 = minY + rand.nextInt(rangeY);
             int l11 = z + rand.nextInt(16);
-            (new WorldFeatureOre(Blocks.DIRT.id, 32)).place(world, rand, l5, i9, l11);
+            (new WorldFeatureOre(Blocks.DIRT.id(), 32)).place(world, rand, l5, i9, l11);
         }
 
         for (int k2 = 0; k2 < (10 * oreHeightModifier); k2++) {
             int i6 = x + rand.nextInt(16);
             int j9 = minY + rand.nextInt(rangeY);
             int i12 = z + rand.nextInt(16);
-            (new WorldFeatureOre(Blocks.GRAVEL.id, 32)).place(world, rand, i6, j9, i12);
+            (new WorldFeatureOre(Blocks.GRAVEL.id(), 32)).place(world, rand, i6, j9, i12);
         }
 
         for (int i3 = 0; i3 < (20 * oreHeightModifier); i3++) {
             int j6 = x + rand.nextInt(16);
             int k9 = minY + rand.nextInt(rangeY);
             int j12 = z + rand.nextInt(16);
-            new WorldFeatureOre(BlockOreCoal.variantMap, 16).place(world, rand, j6, k9, j12);
+            new WorldFeatureOre(BlockLogicOreCoal.variantMap, 16).place(world, rand, j6, k9, j12);
         }
 
         for (int j3 = 0; j3 < (20 * oreHeightModifier); j3++) {
             int k6 = x + rand.nextInt(16);
             int l9 = minY + rand.nextInt(rangeY / 2);
             int k12 = z + rand.nextInt(16);
-            (new WorldFeatureOre(BlockOreIron.variantMap, 8)).place(world, rand, k6, l9, k12);
+            (new WorldFeatureOre(BlockLogicOreIron.variantMap, 8)).place(world, rand, k6, l9, k12);
         }
 
         for (int k3 = 0; k3 < (2 * oreHeightModifier); k3++) {
             int l6 = x + rand.nextInt(16);
             int i10 = minY + rand.nextInt(rangeY / 4);
             int l12 = z + rand.nextInt(16);
-            (new WorldFeatureOre(BlockOreGold.variantMap, 8)).place(world, rand, l6, i10, l12);
+            (new WorldFeatureOre(BlockLogicOreGold.variantMap, 8)).place(world, rand, l6, i10, l12);
         }
 
         for (int l3 = 0; l3 < (8 * oreHeightModifier); l3++) {
             int i7 = x + rand.nextInt(16);
             int j10 = minY + rand.nextInt(rangeY / 8);
             int i13 = z + rand.nextInt(16);
-            (new WorldFeatureOre(BlockOreRedstone.variantMap, 7)).place(world, rand, i7, j10, i13);
+            (new WorldFeatureOre(BlockLogicOreRedstone.variantMap, 7)).place(world, rand, i7, j10, i13);
         }
 
         for (int i4 = 0; i4 < oreHeightModifier; i4++) {
             int j7 = x + rand.nextInt(16);
             int k10 = minY + rand.nextInt(rangeY / 8);
             int j13 = z + rand.nextInt(16);
-            (new WorldFeatureOre(BlockOreDiamond.variantMap, 7)).place(world, rand, j7, k10, j13);
+            (new WorldFeatureOre(BlockLogicOreDiamond.variantMap, 7)).place(world, rand, j7, k10, j13);
         }
 
         for (int i4 = 0; i4 < oreHeightModifier; i4++) {
             int j7 = x + rand.nextInt(16);
             int k10 = minY + rand.nextInt(rangeY / 2);
             int j13 = z + rand.nextInt(16);
-            (new WorldFeatureOre(BlockMoss.variantMap, 32)).place(world, rand, j7, k10, j13);
+            (new WorldFeatureOre(BlockLogicMoss.variantMap, 32)).place(world, rand, j7, k10, j13);
         }
 
         for (int j4 = 0; j4 < oreHeightModifier; j4++) {
             int k7 = x + rand.nextInt(16);
             int l10 = minY + rand.nextInt(rangeY / 8) + rand.nextInt(rangeY / 8);
             int k13 = z + rand.nextInt(16);
-            (new WorldFeatureOre(BlockOreLapis.variantMap, 6)).place(world, rand, k7, l10, k13);
+            (new WorldFeatureOre(BlockLogicOreLapis.variantMap, 6)).place(world, rand, k7, l10, k13);
         }
 
 
@@ -288,7 +287,7 @@ public class ChunkDecoratorOverworld
         }
         if (treeDensityOverride != -1) treeDensity = treeDensityOverride;
         try {
-        	BlockLeavesBase.enableDecay = false;
+        	BlockLogicLeavesBase.enableDecay = false;
             for (int i11 = 0; i11 < treeDensity; i11++) {
                 int l13 = x + rand.nextInt(16) + 8;
                 int j14 = z + rand.nextInt(16) + 8;
@@ -297,7 +296,7 @@ public class ChunkDecoratorOverworld
                 feature.place(world, rand, l13, world.getHeightValue(l13, j14), j14);
             }
         }finally {
-        	BlockLeavesBase.enableDecay = true;
+            BlockLogicLeavesBase.enableDecay = true;
         }
         byte byteReeds = 0;
         if (biome == Biomes.OVERWORLD_RAINFOREST) {
@@ -318,7 +317,7 @@ public class ChunkDecoratorOverworld
             byteOrchid = 1;
         }
         for (int l14 = 0; l14 < byteOrchid; l14++) {
-            int[] flowerIds= { Blocks.FLOWER_YELLOW.id, Blocks.FLOWER_PINK.id, Blocks.FLOWER_RED.id };
+            int[] flowerIds= { Blocks.FLOWER_YELLOW.id(), Blocks.FLOWER_PINK.id(), Blocks.FLOWER_RED.id() };
 
             int l19 = x + rand.nextInt(16) + 8;
             int k22 = rand.nextInt(world.getHeightBlocks());
@@ -341,12 +340,12 @@ public class ChunkDecoratorOverworld
         }
 
         for (int l14 = 0; l14 < byteMeadow; l14++) {
-            int blockId = Blocks.FLOWER_PURPLE.id;
+            int blockId = Blocks.FLOWER_PURPLE.id();
             if (rand.nextInt(12) == 0) {
-                blockId = Blocks.FLOWER_RED.id;
+                blockId = Blocks.FLOWER_RED.id();
             }
             if (rand.nextInt(6) == 0) {
-                blockId = Blocks.FLOWER_YELLOW.id;
+                blockId = Blocks.FLOWER_YELLOW.id();
             }
             int l19 = x + rand.nextInt(16) + 8;
             int k22 = rand.nextInt(world.getHeightBlocks());
@@ -372,7 +371,7 @@ public class ChunkDecoratorOverworld
             int k14 = x + rand.nextInt(16) + 8;
             int l16 = minY + rand.nextInt(rangeY);
             int k19 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Blocks.FLOWER_LIGHT_BLUE.id, 64, true)).place(world, rand, k14, l16, k19);
+            (new WorldFeatureFlowers(Blocks.FLOWER_LIGHT_BLUE.id(), 64, true)).place(world, rand, k14, l16, k19);
         }
 
         byte byteMarigold = 0;
@@ -395,7 +394,7 @@ public class ChunkDecoratorOverworld
             int k14 = x + rand.nextInt(16) + 8;
             int l16 = minY + rand.nextInt(rangeY);
             int k19 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Blocks.FLOWER_ORANGE.id, 64, true)).place(world, rand, k14, l16, k19);
+            (new WorldFeatureFlowers(Blocks.FLOWER_ORANGE.id(), 64, true)).place(world, rand, k14, l16, k19);
         }
 
         byte byte0 = 0;
@@ -423,7 +422,7 @@ public class ChunkDecoratorOverworld
             int k14 = x + rand.nextInt(16) + 8;
             int l16 = minY + rand.nextInt(rangeY);
             int k19 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Blocks.FLOWER_YELLOW.id, 64, true)).place(world, rand, k14, l16, k19);
+            (new WorldFeatureFlowers(Blocks.FLOWER_YELLOW.id(), 64, true)).place(world, rand, k14, l16, k19);
         }
 
         byte byte1 = 0;
@@ -458,9 +457,9 @@ public class ChunkDecoratorOverworld
             byte1 = 2;
         }
         for (int l14 = 0; l14 < byte1; l14++) {
-            int type = Blocks.TALLGRASS.id;
+            int type = Blocks.TALLGRASS.id();
             if ((biome == Biomes.OVERWORLD_RAINFOREST || biome == Biomes.OVERWORLD_SWAMPLAND || biome == Biomes.OVERWORLD_BOREAL_FOREST || biome == Biomes.OVERWORLD_TAIGA) && rand.nextInt(3) != 0) {
-                type = Blocks.TALLGRASS_FERN.id;
+                type = Blocks.TALLGRASS_FERN.id();
             }
             int l19 = x + rand.nextInt(16) + 8;
             int k22 = minY + rand.nextInt(rangeY);
@@ -490,26 +489,26 @@ public class ChunkDecoratorOverworld
             int i17 = x + rand.nextInt(16) + 8;
             int i20 = minY + rand.nextInt(rangeY);
             int l22 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureDeadBush(Blocks.DEADBUSH.id)).place(world, rand, i17, i20, l22);
+            (new WorldFeatureDeadBush(Blocks.DEADBUSH.id())).place(world, rand, i17, i20, l22);
         }
 
         if (rand.nextInt(2) == 0) {
             int j15 = x + rand.nextInt(16) + 8;
             int j17 = minY + rand.nextInt(rangeY);
             int j20 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Blocks.FLOWER_RED.id, 64, true)).place(world, rand, j15, j17, j20);
+            (new WorldFeatureFlowers(Blocks.FLOWER_RED.id(), 64, true)).place(world, rand, j15, j17, j20);
         }
         if (rand.nextInt(4) == 0) {
             int k15 = x + rand.nextInt(16) + 8;
             int k17 = minY + rand.nextInt(rangeY);
             int k20 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Blocks.MUSHROOM_BROWN.id, 64, false)).place(world, rand, k15, k17, k20);
+            (new WorldFeatureFlowers(Blocks.MUSHROOM_BROWN.id(), 64, false)).place(world, rand, k15, k17, k20);
         }
         if (rand.nextInt(8) == 0) {
             int l15 = x + rand.nextInt(16) + 8;
             int l17 = minY + rand.nextInt(rangeY);
             int l20 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureFlowers(Blocks.MUSHROOM_RED.id, 64, false)).place(world, rand, l15, l17, l20);
+            (new WorldFeatureFlowers(Blocks.MUSHROOM_RED.id(), 64, false)).place(world, rand, l15, l17, l20);
         }
         if(rand.nextInt(5) == 0) {
             int i18 = x + rand.nextInt(16) + 8;
@@ -555,7 +554,7 @@ public class ChunkDecoratorOverworld
             int l21 = x + rand.nextInt(16) + 8;
             int k23 = minY + rand.nextInt(rand.nextInt(rangeY - (rangeY / 16)) + (rangeY / 16));
             int l24 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureLiquid(Blocks.FLUID_WATER_FLOWING.id)).place(world, rand, l21, k23, l24);
+            (new WorldFeatureLiquid(Blocks.FLUID_WATER_FLOWING.id())).place(world, rand, l21, k23, l24);
         }
 
         for(int i19 = 0; i19 < 20; i19++)
@@ -563,7 +562,7 @@ public class ChunkDecoratorOverworld
             int i22 = x + rand.nextInt(16) + 8;
             int l23 = minY + rand.nextInt(rand.nextInt(rand.nextInt(rangeY - (rangeY / 8)) + (rangeY / 16)) + (rangeY / 16));
             int i25 = z + rand.nextInt(16) + 8;
-            (new WorldFeatureLiquid(Blocks.FLUID_LAVA_FLOWING.id)).place(world, rand, i22, l23, i25);
+            (new WorldFeatureLiquid(Blocks.FLUID_LAVA_FLOWING.id())).place(world, rand, i22, l23, i25);
         }
 
         int oceanY = world.getWorldType().getOceanY();
@@ -578,19 +577,19 @@ public class ChunkDecoratorOverworld
                 {
                     if (world.isAirBlock(dx, dy, dz) && world.getBlockMaterial(dx, dy - 1, dz).blocksMotion())
                     {
-                        world.setBlockWithNotify(dx, dy, dz, Blocks.LAYER_SNOW.id);
+                        world.setBlockWithNotify(dx, dy, dz, Blocks.LAYER_SNOW.id());
                     }
                 }
-                if ((localBiome.hasSurfaceSnow() || world.worldType == WorldTypes.OVERWORLD_WINTER) && (world.getBlockId(dx, oceanY - 1, dz) == Blocks.FLUID_WATER_STILL.id || world.getBlockId(dx, oceanY - 1, dz) == Blocks.FLUID_WATER_FLOWING.id))
+                if ((localBiome.hasSurfaceSnow() || world.worldType == WorldTypes.OVERWORLD_WINTER) && (world.getBlockId(dx, oceanY - 1, dz) == Blocks.FLUID_WATER_STILL.id() || world.getBlockId(dx, oceanY - 1, dz) == Blocks.FLUID_WATER_FLOWING.id()))
                 {
-                    world.setBlockWithNotify(dx, oceanY - 1, dz, Blocks.ICE.id);
+                    world.setBlockWithNotify(dx, oceanY - 1, dz, Blocks.ICE.id());
                 }
 
             }
 
         }
 
-        BlockSand.fallInstantly = false;
+        BlockLogicSand.fallInstantly = false;
         world.scheduledUpdatesAreImmediate = false;
     }
 }
